package it.unibas.indovinailnumero.modello;

public class Partita {

    private static java.util.Random generatore = new java.util.Random();

    private String nome;
    private int numeroDaIndovinare;
    private int numeroDiTentativi;
    private boolean trovato;
    private String suggerimento;

    public Partita() {
        this.numeroDaIndovinare = Math.abs(Partita.generatore.nextInt(100) + 1);
        it.unibas.utilita.Logger.logFine("Numero scelto: " + numeroDaIndovinare);
        this.trovato = false;
        this.numeroDiTentativi = 0;
        this.suggerimento = "Ho scelto un numero tra 1 e 100. Prova a indovinarlo.";
    }

    public void setNome(String nome) {
        this.nome = nome;
    }

    public void gestisciTentativo(int tentativo) {
        if ((tentativo < 1) || (tentativo > 100)) {
            throw new IllegalArgumentException("Il valore deve essere compreso tra 1 e 100");
        }
        it.unibas.utilita.Logger.logFine("Partita", "gestisciTentativo", "Tentativo: " + tentativo);
        this.numeroDiTentativi++;
        it.unibas.utilita.Logger.logFine("Partita", "gestisciTentativo", "Num. tentativi: " + numeroDiTentativi);
        if (tentativo == this.numeroDaIndovinare) {
            this.trovato = true;
            this.suggerimento = "Numero indovinato";
        } else if (tentativo < numeroDaIndovinare) {
            this.suggerimento = "Prova con un numero piu' alto";
        } else if (tentativo > numeroDaIndovinare) {
            this.suggerimento = "Prova con un numero piu' basso";
        }
        it.unibas.utilita.Logger.logFine("Partita", "gestisciTentativo", "Suggerimento: " + suggerimento);
    }

    public boolean getTrovato() {
        return this.trovato;
    }

    public String getSuggerimento() {
        return this.suggerimento;
    }

    public int getNumeroDiTentativi() {
        return this.numeroDiTentativi;
    }

    public int getNumeroDaIndovinare() {
        return this.numeroDaIndovinare;
    }

    public String getNome() {
        return this.nome;
    }

}

