package it.unibas.indovinailnumero.modello;

public class Record {

    private String nomeFileRecord;
    private boolean nuovoRecord;
    private boolean uguagliato;

    public Record() {
        String tempDir = System.getProperty("java.io.tmpdir");
        this.nomeFileRecord = tempDir + "recordIndovina.txt";
    }

    public boolean isNuovoRecord() {
        return this.nuovoRecord;
    }

    public boolean isUguagliato() {
        return this.uguagliato;
    }

    public void checkRecord(int tentativi) {
        if (tentativi < 1) {
            throw new IllegalArgumentException("Numero di tentativi scorretto");
        }
        it.unibas.utilita.Logger.logFine("Record", "checkRecord", "tentativi: " + tentativi);
        this.nuovoRecord = false;
        this.uguagliato = false;
        int valoreRecord = getValoreRecord();
        it.unibas.utilita.Logger.logFine("Record", "checkRecord", "attuale record: " + valoreRecord);
        if (tentativi < valoreRecord) {
            setValoreRecord(tentativi);
            this.nuovoRecord = true;
            it.unibas.utilita.Logger.logFine("Record", "checkRecord", "record battuto");
        } else if (tentativi == valoreRecord) {
            this.uguagliato = true;
            it.unibas.utilita.Logger.logFine("Record", "checkRecord", "record uguagliato");
        }
    }

    public int getValoreRecord() {
        int valoreRecord;
        java.io.BufferedReader file = null;
        try {
            file = new java.io.BufferedReader(
                       new java.io.FileReader(this.nomeFileRecord));
            String linea = file.readLine();
            valoreRecord = Integer.parseInt(linea);
        } catch (java.io.FileNotFoundException f) {
            it.unibas.utilita.Logger.logFine("Record", "getValoreRecord", "Errore nella lettura del record " + f);
            valoreRecord = 101;
        } catch (java.io.IOException e) {
            it.unibas.utilita.Logger.logFine("Record", "getValoreRecord", "Errore nella lettura del record " + e);
            valoreRecord = 101;
        } catch (NumberFormatException nfe) {
            it.unibas.utilita.Logger.logFine("Record", "getValoreRecord", "Errore nella lettura del record " + nfe);
            valoreRecord = 101;
        } finally {
            try {
                if (file != null) {
                    file.close();
                }
            } catch (java.io.IOException ioe) {}
        }
        return valoreRecord;
    }

    public void reset() {
        try {
            java.io.File file = new java.io.File(this.nomeFileRecord);
            file.delete();
        } catch (SecurityException e) {
            it.unibas.utilita.Logger.logSevere("Record", "reset", "Errore nella cancellazione del record " + e);
        }
    }

    private void setValoreRecord(int valoreRecord) {
        if (valoreRecord < 1) {
            throw new IllegalArgumentException("Numero di tentativi scorretto");
        }
        java.io.PrintWriter file = null;
        try {
            file = new java.io.PrintWriter(
                           new java.io.FileWriter(this.nomeFileRecord));
            file.println(valoreRecord + "");
            file.close();
        } catch (java.io.IOException e) {
            it.unibas.utilita.Logger.logSevere("Record", "setValoreRecord", "Impossibile salvare il record " + e);
        } finally {
            if (file != null) {
                file.close();
            }
        }
    }

}
