package it.unibas.indovinailnumero.test;

import junit.framework.*;
import it.unibas.indovinailnumero.modello.Partita;

public class TestPartita extends TestCase {

    private Partita partita;

    public void setUp() {
        partita = new Partita();
    }

    public void testPartita1() {
        for (int i = 0; i < 200; i++) {
            Partita partita = new Partita();
            Assert.assertTrue("numero", (partita.getNumeroDaIndovinare() >= 1
                                      && partita.getNumeroDaIndovinare() <= 100));
            Assert.assertTrue("trovato", partita.getTrovato() == false);
            Assert.assertTrue("tentativi", partita.getNumeroDiTentativi() == 0);
        }
    }

    public void testSetTentativoBasso() {
        int tentativi = partita.getNumeroDiTentativi();
        int numeroDaIndovinare = partita.getNumeroDaIndovinare();
        if (numeroDaIndovinare > 1) {
            partita.gestisciTentativo(numeroDaIndovinare - 1);
            String suggerimento = partita.getSuggerimento();
            Assert.assertTrue("suggerimento", suggerimento.equals("Prova con un numero piu' alto"));
            Assert.assertTrue("trovato", partita.getTrovato() == false);
            Assert.assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi + 1);
        }
    }

    public void testSetTentativoAlto() {
        int tentativi = partita.getNumeroDiTentativi();
        int numeroDaIndovinare = partita.getNumeroDaIndovinare();
        if (numeroDaIndovinare < 100) {
            partita.gestisciTentativo(numeroDaIndovinare + 1);
            String suggerimento = partita.getSuggerimento();
            Assert.assertTrue("suggerimento", suggerimento.equals("Prova con un numero piu' basso"));
            Assert.assertTrue("trovato", partita.getTrovato() == false);
            Assert.assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi + 1);
        }
    }

    public void testSetTentativoEsatto() {
        int tentativi = partita.getNumeroDiTentativi();
        int numeroDaIndovinare = partita.getNumeroDaIndovinare();
        partita.gestisciTentativo(numeroDaIndovinare);
        String suggerimento = partita.getSuggerimento();
        Assert.assertTrue("suggerimento", suggerimento.equals("Numero indovinato"));
        Assert.assertTrue("trovato", partita.getTrovato() == true);
        Assert.assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi + 1);
    }

    public void testSetTentativoTroppoBasso() {
        int tentativi = partita.getNumeroDiTentativi();
        try {
            partita.gestisciTentativo(-1);
            Assert.fail();
        } catch (IllegalArgumentException e) {}
        Assert.assertTrue("trovato", partita.getTrovato() == false);
        Assert.assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi);
    }

    public void testSetTentativoTroppoAlto() {
        int tentativi = partita.getNumeroDiTentativi();
        try {
            partita.gestisciTentativo(200);
            Assert.fail();
        } catch (IllegalArgumentException e) {}
        Assert.assertTrue("trovato", partita.getTrovato() == false);
        Assert.assertTrue("tentativi", partita.getNumeroDiTentativi() == tentativi);
    }

}
