package it.unibas.indovinailnumero.test;

import junit.framework.*;
import it.unibas.indovinailnumero.modello.Record;

public class TestRecord extends TestCase {

    private Record record;

    public void setUp() {
        record = new Record();
    }

    public void testRecord1() {
        record.reset();
        int valoreIniziale = record.getValoreRecord();
        Assert.assertTrue("valore iniziale",  (valoreIniziale == 101));
        record.checkRecord(10);
        Assert.assertTrue("valore 10", record.getValoreRecord() == 10);
    }

    public void testRecord2() {
        record.reset();
        record.checkRecord(10);
        record.checkRecord(200);
        Assert.assertTrue("valore 10", record.getValoreRecord() == 10);
    }

    public void testRecord3() {
        record.reset();
        record.checkRecord(10);
        Assert.assertTrue("nuovo record", record.isNuovoRecord() == true);
        Assert.assertTrue("no uguagliato", record.isUguagliato() == false);
        record.checkRecord(20);
        Assert.assertTrue("no nuovo record", record.isNuovoRecord() == false);
        Assert.assertTrue("no uguagliato bis", record.isUguagliato() == false);
    }

    public void testRecordException() {
        record.reset();
        record.checkRecord(10);
        try {
            record.checkRecord(-1);
            Assert.fail();
        } catch (IllegalArgumentException e) {}
    }

    public void testNuovoRecord() {
        record.reset();
        record.checkRecord(10);
        record.checkRecord(3);
        Assert.assertTrue("nuovo record", record.isNuovoRecord() == true);
        Assert.assertTrue("uguagliato", record.isUguagliato() == false);
        Assert.assertTrue("valore record", record.getValoreRecord() == 3);
    }

    public void testRecordUguagliato() {
        record.reset();
        record.checkRecord(3);
        record.checkRecord(3);
        Assert.assertTrue("nuovo record", record.isNuovoRecord() == false);
        Assert.assertTrue("uguagliato", record.isUguagliato() == true);
        Assert.assertTrue("valore record", record.getValoreRecord() == 3);
    }
}

